﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel;
using System.Text;
using System.Threading.Tasks;

namespace Company.Infrastructure.Client
{
    [AttributeUsage(AttributeTargets.Method, AllowMultiple = false, Inherited = false)]
    public abstract class PolicyProxyAttribute : Attribute
    {
        public abstract string GetBindingName();

        public abstract PolicyProxyBase<T> CreateProxy<T>(Uri address) where T : class;

        public abstract PolicyProxyBase<T> CreateProxy<T>(EndpointAddress endpointAddress) where T : class;
    }
}
