﻿using System;
using Company.Infrastructure.Client;

namespace Company.Infrastructure.Policy.Intranet.Client
{
    [AttributeUsage(AttributeTargets.Class, AllowMultiple = false, Inherited = false)]
    public class IntranetPolicy : PolicyProxyAttribute
    {
        public override PolicyProxyBase<T> CreateProxy<T>(Uri address)
        {
            return new IntranetProxy<T>(address);
        }

        public override PolicyProxyBase<T> CreateProxy<T>(System.ServiceModel.EndpointAddress endpointAddress)
        {
            return new IntranetProxy<T>(endpointAddress);
        }

        public override string GetBindingName()
        {
            return "netTcpBinding";
        }
    }
}