﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Security.Claims;
using ServiceModelEx;
using ServiceModelEx.Security.Principal;

namespace Company.Infrastructure.ServiceModel.Proxies.Legacy
{
    [System.Web.Services.WebServiceBindingAttribute(Name = "WorkflowSoap", Namespace = "http://Company.net/services/2015/02")]
    public partial class FederatedAsmxClientBase : System.Web.Services.Protocols.SoapHttpClientProtocol
    {
        public FederatedAsmxClientBase(string url)
        {
            if (string.IsNullOrWhiteSpace(url))
            {
                throw new ArgumentNullException("url");
            }

            this.Url = url;

            if (SecurityCallStackContext.Current != null && SecurityCallStackContext.Current.LastCall != null &&
                SecurityCallStackContext.Current.LastCall.Claims != null && SecurityCallStackContext.Current.LastCall.Claims.Any())
            {
                IEnumerable<Claim> claims = SecurityCallStackContext.Current.LastCall.Claims;

                Claim fedAuth = claims.FirstOrDefault(claim => claim.Type == CustomClaimTypes.FedAuth);
                Claim fedAuth1 = claims.FirstOrDefault(claim => claim.Type == CustomClaimTypes.FedAuth1);

                string domainName = new Uri(url).Host;
                this.CookieContainer = new CookieContainer();

                if (fedAuth != null)
                {
                    this.CookieContainer.Add(new Cookie("FedAuth", fedAuth.Value) { Domain = domainName });
                }

                if (fedAuth1 != null)
                {
                    this.CookieContainer.Add(new Cookie("FedAuth1", fedAuth1.Value) { Domain = domainName });
                }
            }
        }
    }
}