﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel.Description;
using System.Text;
using System.Web.Services.Protocols;

namespace Company.Infrastructure.ServiceModel.Soap.Attributes
{
    [AttributeUsage(AttributeTargets.Method, AllowMultiple = true)]
    public class SoapHeaderContactAttribute : Attribute
    {
        string name;
        Type type;
        SoapHeaderDirection direction = SoapHeaderDirection.In;

        public SoapHeaderContactAttribute(string name, Type type)
        {
            this.name = name;
            this.type = type;
        }

        public string Name
        {
            get
            {
                return name;
            }
        }

        public string Namespace { get; set; }

        public Type Type
        {
            get
            {
                return type;
            }
        }

        public SoapHeaderDirection Direction
        {
            get
            {
                return direction;
            }
            set
            {
                direction = value;
            }
        }
    }
}
