﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ServiceModelEx;
using System.IO;
using System.Runtime.Serialization.Json;
using ServiceModelEx.Security.Principal;
using System.Security.Claims;

namespace ServiceModelEx.Extensions
{
    /// <summary>
    /// Extension methods for retriving user data out of the security context.
    /// </summary>
    public static class SecurityCallStackExtensions
    {
        public static IdentityUserData ToIdentityUserData(this SecurityCallStack callStack)
        {
            IEnumerable<Claim> claims = callStack != null && callStack.OriginalCall != null ? callStack.OriginalCall.Claims : new Claim[0];

//Ensure that this code can never execute in a release build
#if DEBUG
            //// DO NOT CHECK IN CHANGES TO THIS DEBUG BLOCK
            //// This will ensure that calls are authenticated as the admin user when calling from WcfTestClient.exe. 
            //// Only uncomment this when you need it, this causes havoc when devs are running the code from the web 
            //// clients as you will always be logged in as admin
            //IList<Claim> debugClaims = new List<Claim>();
            //debugClaims.Add(new Claim(ClaimTypes.NameIdentifier, "1000"));
            //debugClaims.Add(new Claim(ClaimTypes.Name, "Administrator Account"));
            //debugClaims.Add(new Claim(ClaimTypes.Email, "admin@Company.net"));
            //debugClaims.Add(new Claim(CustomClaimTypes.UserLanguages, "1"));
            //debugClaims.Add(new Claim(CustomClaimTypes.ClientWebsiteUrl, "https://localhost/ScalableWebSite/"));
            //return new IdentityUserData(debugClaims.Union(claims));
#endif           
            IdentityUserData.AddIdentity(claims);
            return new IdentityUserData();
        }
    }
}