//  2011 IDesign Inc. All rights reserved 
//Questions? Comments? go to 
//http://www.idesign.net

using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.Security.Claims;

namespace ServiceModelEx
{
    [DataContract]
    public class SecurityCallFrame
    {
        internal SecurityCallFrame()
        {
            this.TimeStamp = DateTime.UtcNow;
        }

        internal SecurityCallFrame(IEnumerable<Claim> claims) 
            : this()
        {
            this.Claims = claims;
        }

        [DataMember(IsRequired = true)]
        public IEnumerable<Claim> Claims { get; internal set; }

        [DataMember(IsRequired = true)]
        public DateTime TimeStamp { get; private set; }
    }
}
