﻿using System.Runtime.InteropServices;

namespace ServiceModelEx.Security.Principal
{
    /// <summary>
    /// Defines constants for the custom claim types that can be assigned to a subject. This class cannot be inherited.
    /// </summary>
    [ComVisible(false)]
    public static class CustomClaimTypes
    {
        public const string ClaimTypesBase = "http://schemas.Company.net/ws/";

        /// <summary>
        /// The ID identifying a related change of service calls, a GUID, http://schemas.Company.net/ws/2014/08/identity/claims/activity
        /// </summary>
        public const string ActivityId = CustomClaimTypes.ClaimTypesBase + "/2014/08/identity/claims/activity";

        /// <summary>
        /// The address of the caller, machine name or IP address, http://schemas.Company.net/ws/2014/08/identity/claims/calleraddress
        /// </summary>
        public const string CallerAddress = CustomClaimTypes.ClaimTypesBase + "/2014/08/identity/claims/calleraddress";

        /// <summary>
        /// The type of the caller, a class type or application name, http://schemas.Company.net/ws/2014/08/identity/claims/callertype
        /// </summary>
        public const string CallerType = CustomClaimTypes.ClaimTypesBase + "/2014/08/identity/claims/callertype";

        /// <summary>
        /// The claim type for the user's culture, http://schemas.Company.net/ws/2014/08/identity/claims/userculture
        /// </summary>
        public const string Culture = CustomClaimTypes.ClaimTypesBase + "/2014/08/identity/claims/userculture";

        /// <summary>
        /// The claim type for the user's theme, http://schemas.Company.net/ws/2014/08/identity/claims/usertheme
        /// </summary>
        public const string Theme = CustomClaimTypes.ClaimTypesBase + "/2014/08/identity/claims/usertheme";

        /// <summary>
        /// The claim type for the user's spoken languages, http://schemas.Company.net/ws/2014/08/identity/claims/userlanguages
        /// </summary>
        public const string UserLanguages = CustomClaimTypes.ClaimTypesBase + "/2014/08/identity/claims/userlanguages";

        /// <summary>
        /// The claim to the clients website url, http://schemas.Company.net/ws/2014/09/identity/claims/clientWebsiteUrl
        /// </summary>
        public const string ClientWebsiteUrl = CustomClaimTypes.ClaimTypesBase + "/2014/09/identity/claims/clientWebsiteUrl";

        /// <summary>
        /// The claim type for the user's capabilities, http://schemas.Company.net/ws/2014/11/identity/claims/capabilities
        /// </summary>
        public const string Capabilities = CustomClaimTypes.ClaimTypesBase + "/2014/11/identity/claims/capabilities";

        /// <summary>
        /// The FedAuth token, http://schemas.Company.net/ws/2015/03/identity/claims/fedauth
        /// </summary>
        public const string FedAuth = CustomClaimTypes.ClaimTypesBase + "/2015/03/identity/claims/fedauth";

        /// <summary>
        /// The FedAuth token, http://schemas.Company.net/ws/2015/03/identity/claims/fedauth1
        /// </summary>
        public const string FedAuth1 = CustomClaimTypes.ClaimTypesBase + "/2015/03/identity/claims/fedauth1";
    }
}